#ifndef _ERROR_H_
#define _ERROR_H_

#include <string>
#include <stdio.h>

#define ERROR(desc) Error(__FILE__, __LINE__, desc)

static const std::string default_error_desc = "Unknown error";

class Error {
	public:
		Error(const std::string & _desc = default_error_desc) :
			desc(_desc), line(-1U)
		{ }

		Error(const std::string & _file, unsigned int _line, const std::string & _desc = default_error_desc) :
			desc(_desc), file(_file), line(_line)
		{ }

		void Dump(FILE *fo = stderr) const {
			fprintf(fo, "Error");
			if (line != -1U)
				fprintf(fo, " (@%s:%u)", file.c_str(), line);
			fprintf(fo, ": %s\n", desc.c_str());
		}

	public:
		std::string desc, file;
		unsigned int line;
};

#endif
