#ifndef _PARSER_H_
#define _PARSER_H_

#include <string>

#include "tree.h"
#include "error.h"
#include "tokenizer.h"

using namespace std;


class Parser {
	public:
		Tree tree;

		Parser() : verbose(false), _root_func_name("main") {}

		void SetVerbose(bool v) {
			verbose = v;
			ulaz.verbose = v;
		}

		Token GetCurrentToken() const;
		const string & GetRootFunctionName() const { return _root_func_name; }
		bool SetRootFunctionName(const string & fn);

		bool operator << (const Tokenizer &t);

	private:
		CTokenStream ulaz;
		bool verbose;
		string _root_func_name;

		const vector<TreeNode> Argumenti();
		TreeNode Function(const string & call_type);
		TreeNode Izraz();
		void Petlja(TreeNode &);
		void Block(TreeNode &);
		void Command(TreeNode &);
		void CommandList(TreeNode &);

		static TreeNode NodeFromToken(const Token &tok);
};

class ParseError : public Error {
	public:
		ParseError(string _desc) : Error("Parse error: " + _desc) {}
};

#endif
