" Vim syntax file
" Language:	cj (Cudan jezik)
" Filenames:	*.cj

if version < 600
	syntax clear
"elseif exists("b:current_syntax")
"	finish
endif

syn keyword Keyword	return if else for while arg
syn keyword Type	extern function push
"syn keyword Number	NULL

" call
syn keyword cjCall	contained call stdcall
syn region cjCallF	display start=+\(call\|stdcall\)\(\s\|$\)+ end=+\s*[a-zA-Z_0-9]\++ contains=cjCall

" string
syn match	cjSpecial	display contained "\\\(x\x\+\|\o\{1,3}\|.\|$\)"
syn match	cjFormat	display "%\(\d\+\$\)\=[-+' #0*]*\(\d*\|\*\|\*\d\+\$\)\(\.\(\d*\|\*\|\*\d\+\$\)\)\=\([hlLjzt]\|ll\|hh\)\=\([aAbdiuoxXDOUfFeEgGcCsSpn]\|\[\^\=.[^]]*\]\)" contained
syn match	cjFormat	display "%%" contained
syn region	cjString	start=+"+ skip=+\\\\\|\\"+ end=+"+ contains=cjSpecial,cjFormat,@Spell

" number
syn case ignore
syn match       cjNumbers        display "\<\d\|\.\d" contains=cjNumber,cjOctalError,cjOctal
syn match	cjNumber	display contained "0x\x\+\>"
syn match	cjOctal		display contained "0\o\+\>" contains=cjOctalZero
syn match	cjOctalZero	display contained "\<0"
syn match	cjNumber	display contained "[1-9]\d\+\>"
syn match       cjOctalError	display contained "0\o*[89]\d*"
syn match	cjHexError	display contained "0x\x*[g-zG-Z]\x*"

" comment
syn region	cjCommentL	start="//" skip="\\$" end="$" keepend
syn region	cjComment	matchgroup=cjCommentStart start="/\*" end="\*/" contains=cjCommentStartError
syn match	cjCommentStartError	display contained "/\*"

" preprocessor
syn region	cjPreCondit	start="^\s*\(%:\|#\)\s*\(if\|ifdef\|ifndef\|elif\)\>" skip="\\$" end="$" end="//"me=s-1 contains=cjComment,cjNumbers
syn match	cjPreCondit	display "^\s*\(%:\|#\)\s*\(else\|endif\)\>"
syn region	cjIncluded	display contained start=+"+ skip=+\\\\\|\\"+ end=+"+
syn match	cjIncluded	display contained "<[^>]*>"
syn match	cjInclude	display "^\s*\(%:\|#\)\s*include\>\s*["<]" contains=cjIncluded
syn cluster	cjPreProcGroup	contains=cjPreCondit,cjIncluded,cjInclude,cjDefine,cjOctalZero,cjFormat,cjNumber,cjOctal,cjOctalError,cjString,cjCommentStartError
syn region	cjDefine	start="^\s*\(%:\|#\)\s*\(define\|undef\)\>" skip="\\$" end="$" end="//"me=s-1 keepend contains=ALLBUT,@cjPreProcGroup,@Spell
syn region	cjPreProc	start="^\s*\(%:\|#\)\s*\(pragma\>\|line\>\|warning\>\|warn\>\|error\>\)" skip="\\$" end="$" keepend contains=ALLBUT,@cjPreProcGroup,@Spell

" linkovlje na boje
hi def link cjFormat	SpecialChar
hi def link cjSpecial	SpecialChar
hi def link cjString	String
hi def link cjCall	Keyword
hi def link cjNumbers	Number
hi def link cjOctalError	Error
hi def link cjHexError	Error
hi def link cjCallF	Function
hi def link cjNumber	Number
hi def link cjOctal	Number
hi def link cjOctalZero	SpecialChar
hi def link cjComment	Comment
hi def link cjCommentL	Comment
hi def link cjCommentStart Comment
hi def link cjCommentStartError Error
hi def link cjPreProc	PreProc
hi def link cjDefine	Macro
hi def link cjInclude	Include
hi def link cjIncluded	String
hi def link cjPreCondit	PreCondit

let b:current_syntax = "cj"
